前端算法题:3216. 交换后字典序最小的字符串(力扣每日一题)

今日题目为:3216. 交换后字典序最小的字符串

题目详情:

给你一个仅由数字组成的字符串 s,在最多交换一次 相邻 且具有相同 奇偶性的数字后,返回可以得到的字典序最小的字符串。

如果两个数字都是奇数或都是偶数,则它们具有相同的奇偶性。例如,5 和 9、2 和 4 奇偶性相同,而 6 和 9 奇偶性不同。

示例:

示例 1:

输入: s = "45320"

输出: "43520"

解释:

s[1] == '5' 和 s[2] == '3' 都具有相同的奇偶性,交换它们可以得到字典序最小的字符串。

示例 2:

输入: s = "001"

输出: "001"

解释:

无需进行交换,因为 s 已经是字典序最小的。

解题思路:

首先题目描述说了需要交换一次相邻且具有奇偶性的数字,那么s为字符串,需要交换的话就需要遍历且也要方便交换位置,那么就把s转换为数组形式,在进行遍历,首先需要两数进行交换判断,那么就要想到数组的长度是否为偶数,即i+1<arr.length。首先将遍历元素转换为数字形式,在进行判断两个数字奇偶性是否相同,如果相同再进行判断谁在数字表中最先出现,即谁最小,再根据结果进行交换位置,最后将数组转换为字符串形式输出。

具体解决代码:

javascript 复制代码
var getSmallestString = function(s) {
    const arr = s.split('')
    for(let i = 0; i<arr.length;i++){
        if(i+1<arr.length){
            const num1 = parseInt(s[i],10)
            const num2 = parseInt(s[i+1],10)
            if((num1%2) === (num2%2)){
                if(num1>num2){
                    let temp = arr[i]
                    arr[i] = arr[i+1]
                    arr[i+1] = temp
                    break
                }
            }
        }
    }
    return arr.join('')
};
相关推荐
dialect_7 小时前
KMP算法
开发语言·c++·算法
reikocao7 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
jktantan7 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
前端·javascript·vue.js
漂流瓶jz8 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·8 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
文丑颜不良啊8 小时前
LeetCode1481~1500题目解析
java·leetcode
2601_962885728 小时前
quotes 字段全解:涨跌幅、振幅、换手率的口径与单位
java·前端·spring
excel8 小时前
encodeURI 和 encodeURIComponent 有什么区别?
前端
前端精髓9 小时前
调用openrouter的免费API模型
java·前端·javascript
文丑颜不良啊9 小时前
LeetCode1381~1400题目解析
java·leetcode